#!/bin/sh
#
# Generate a sample of each sound.
#
# On big endian platforms, you'll probably need to add --raw-endianness 1 to
# the parameters to oggenc, since the code in this repository encodes samples
# using the platform's native endianness.

set -e

for sound in bit_chord {,multi_}cycle_timer {,twisted_}hamming_weight {,parity_}hamming_melody shepard_timer; do
    cabal run -v0 .:test_sounds -- --mode stdout "$sound" | oggenc --raw --raw-chan 1 --raw-rate 44100 --raw-bits 16 - > "$sound.ogg"
done
