module SoundStream.BlockUtil (groupListIntoBlocks) where

import Foreign.Storable (Storable)
import qualified SoundStream.Block as Block

{-
groupListIntoBlocks blockSize l segments the list l into blocks of length at
most blockSize. All blocks in the returned list will have that length except
possibly the last. No elements of the output will be empty. blockSize must be
positive.
-}
groupListIntoBlocks :: (Block.Block b, Storable e) => Int -> [e] -> [b e]
groupListIntoBlocks _blockSize [] = []
groupListIntoBlocks blockSize l@(_:_) =
  let (h, t) = splitAt blockSize l
  in Block.fromList h : groupListIntoBlocks blockSize t
