{-

By default, this runs all tests. To test only one module, use the --pattern flag provided by the tasty package. Example:

./test_main --pattern '$2 == "DFT"'

-}

module Main where

import Test.Tasty

-- Modules containing tests
import qualified SoundStream.Block_tests
import qualified SoundStream.BlockUtil_tests
import qualified SoundStream.DFT_tests
import qualified SoundStream.PulseTrack_tests
import qualified SoundStream.PureFFT_tests
import qualified SoundStream.TestPredicates_tests
import qualified SoundStream.TimedClip_tests
import qualified SoundStream.ZeroBasedCArray_tests

main :: IO ()
main = defaultMain $ testGroup "all"
       [ testTests
       , SoundStream.Block_tests.tests
       , SoundStream.BlockUtil_tests.tests
       , SoundStream.DFT_tests.tests
       , SoundStream.PulseTrack_tests.tests
       , SoundStream.PureFFT_tests.tests
       , SoundStream.TimedClip_tests.tests
       , SoundStream.ZeroBasedCArray_tests.tests
       ]

testTests :: TestTree
testTests =
  testGroup "tests for test library"
  [ SoundStream.TestPredicates_tests.tests
  ]
