{-

Predicates for use with Test.QuickCheck.

-}

module SoundStream.TestPredicates where

import Test.QuickCheck (Property, counterexample)

-- @near tolerance x y@ asserts that abs (x-y) is within tolerance. Rejects
-- infinity (infinity + x still tends to be infinity, so accepting these as
-- "near" each other could be misleading).
near :: (Num a, Ord a, Show a) => a -> a -> a -> Property
near tolerance x y =
  let absDifference = abs (x - y)
  in counterexample
     (show x ++ " too far from " ++ show y ++ "; tolerance " ++ show tolerance ++ "; difference " ++ show absDifference)
     (absDifference <= tolerance)
